%data
b=3;                 %bit per symbol
GrayMapping=1;       %use 1 for Gray mapping
w=2000000;            %simulation max length in symbols
wdisplay=5000;       %result display interval
EbN0dB=0:20;         %EbN0 rane in dB
EbN0=10.^(EbN0dB/10);
l=length(EbN0dB);
p0=1/2;              %probability of '0' bit
maxerrors=100;       %stop criterion

if GrayMapping
    [constellation,map]=MPAMmapGray(b);
else
    [constellation,map]=MPAMmap(b);
end


%start simulation
iw=0;
errors=zeros(1,l);
errorsbit=zeros(1,l);
blocks=zeros(1,l);
while iw<w && min(errors)<maxerrors
    iw=iw+1;
    info=rand(1,b)>p0;
    txindex=find(sum((ones(2^b,1)*info)==map,2)==b); %mapping
    tx=constellation(txindex);                       %amplitude
    noise=randn(size(tx));
    for in=1:l
        if errors(in)<maxerrors
            sn=EbN0(in);
            sigma=(1/(2*sn*b))^0.5;
            noise1=noise*sigma;
            rx=tx+noise1;
            dec=MLdecode(rx,constellation);
            if dec~=txindex, errors(in)=errors(in)+1; end
            decinfo=map(dec,:);
            errorsbit(in)=errorsbit(in)+sum(xor(info,decinfo));
            blocks(in)=blocks(in)+1;
        end
    end
    if (rem(iw,wdisplay)==0), errors, iw, end
end
figure(1)
semilogy(EbN0dB,errors./blocks,'k:*');
hold on
semilogy(EbN0dB,(1-1/2^b)*erfc((3*b/(2^(2*b)-1)*EbN0).^0.5),'r-');
figure(2)
if GrayMapping
    semilogy(EbN0dB,errorsbit./blocks/b,'k:*');
else
    semilogy(EbN0dB,errorsbit./blocks/b,'k:o');
end
hold on
semilogy(EbN0dB,(1-1/2^b)/b*erfc((3*b/(2^(2*b)-1)*EbN0).^0.5),'r-');
